// Generated for Telelogic Tau 4.2.0.2.13102 at Thu Apr 16 19:56:53 MEST 2009
// Licensed Materials - Property of IBM 
//  Copyright IBM Corporation 2002,2008.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for Telelogic Tau 4.2.0.2.13102 at Thu Apr 16 19:56:51 MEST 2009
// Licensed Materials - Property of IBM 
//  Copyright IBM Corporation 2002,2008.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// prevent dxl timeout dialog
pragma runLim, 0

void writeTab(Buffer &b, int nTab)
{
    int x
    for (x = 0; x < nTab; x++) {
        b += " "
    }
}

void writeDBHeader(Buffer &b)
{
    b += "package '" 
    b += replaceCharacters(getDatabaseName())
    b += "' {\n"
}

void writeDBFooter(Buffer &b)
{
   b += "}"
}

void writeDBBaselines(Buffer &b, Module &currModule)
{
    b += "baselines = \"" 
    b += replaceCharacters(getBaselinesString(currModule, '|'))
    b += "\""
}

void writeDBViews(Buffer &b, Module &currModule)
{
    b += "views = \"" 
    b += replaceCharacters(getViewsString(currModule, '|')) 
    b += "\""
}

void writeDBItemHeader(Buffer &b, int nTab, Item &currItem, string itemType)
{
    writeTab(b, nTab)
  
    string id = itemType "|" uniqueID(currItem)

    string strName = name(currItem)
    if (length(strName)==1)
    {
		if (isalpha(strName[0]))
		{
			b += "package #d" id "#" strName "# {\n"
		}
		else
		{
			b += "package #d" id "#'\\" strName "'# {\n"
		}
    }
    else
    {
        //add prefix d_m_ in case if first symbol of strName is not letter
		b += "package #d" id "#'d_m_" strName "'# {\n"
	}
}

void writeDBItemFooter(Buffer &b, int nTab)
{
    writeTab(b, nTab)
    b += "}\n"
}


void writeDBItemContent(Buffer &b, int nTab, Item &parentItem, bool isWriteFormalModules)
{
    if (parentItem != null) {
        Item i
        for i in folder parentItem do {
            string itemType = type(i) 
	
            if (itemType == "Link" or itemType == "Descriptive") {
                // Nothing
                continue
            }          

            // "Folder", "Project" or "Formal"
            
            // If 
            if(!isWriteFormalModules && itemType == "Formal")
            {
                continue
            }
            
            if (itemType == "Formal") {
                string itemDescription = description(i)
                if (itemDescription == "Tau Integration Proxy - do not edit") {
                    itemType = "Surrogate"
                }
            }
            
            // "Folder", "Project", "Formal" or "Surrogate"            

           writeDBItemHeader(b, nTab + 4, i, itemType)

           if (itemType == "Folder" || itemType == "Project") {
               writeDBItemContent(b, nTab + 4, i, isWriteFormalModules)			
           }

           writeDBItemFooter(b, nTab + 4)			
        }
    }
}

void writeU2PFile(Buffer &b, bool isWriteFormalModules)
{
    Item rootItem = item("/")

    writeDBHeader(b)
    writeDBItemContent(b, 0, rootItem, isWriteFormalModules)
    writeDBFooter(b)
}

void browseDB()
{
    Buffer b = create
    
    writeU2PFile(b, true)
    returnResult(tempStringOf(b))

    delete b
}

void browseDBFolders()
{
    Buffer b = create
    
    writeU2PFile(b, false)
    returnResult(tempStringOf(b))
 
    delete b
}

/////////////////////////////////////////////////////
/// Get module baselines and views
/////////////////////////////////////////////////////

void getModuleBaselinesAndViews(string moduleId)
{
    Buffer b = create

    Item currItem = itemFromID(moduleId)
    if (type(currItem) == "Formal")
    {
        bool bWasOpened = isModuleOpen(currItem)

        Module m = read (fullName (currItem), false)
        string errMsg = GetLastError()

        if (!null m && null errMsg)
        {
            b += "<<DoorsNodeInfo(."
            writeDBBaselines(b, m)
            b += ", "
            writeDBViews(b, m)
            b += ".)>> "

            if (!bWasOpened)
                close(m)
        }
    }

    string strName = name(currItem)
    if (length(strName)==1)
        b += "package '\\" strName "' {}"
    else
        b += "package '" strName "' {}"


    returnResult(tempStringOf(b))
	
    delete b
}
